/*
  target.cpp

  Copyright (c) 2021 Kevin Matz (kevin.matz@gmail.com)

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#include "target.h"

namespace RDMnet::LLRP {

/**
 * @brief Target::Target
 */
Target::Target()
{
}


/**
 * @brief Target::receiveLLRP
 * @param frame
 */
void Target::receiveLLRP(ACN::PDU::Message<Pdu> frame)
{
  auto data = static_cast<llrp_data*>(frame->data());
  switch (frame->vector()) {
    case VECTOR_LLRP_PROBE_REQUEST:
      receiveProbeRequest(std::static_pointer_cast<ProbeRequest::Pdu>(data->child));
      break;
    case VECTOR_LLRP_RDM_CMD:
      receiveRdmCommand(std::static_pointer_cast<RPT::COMMAND::Pdu>(data->child));
      break;
    default:
      return;
    }
}


/**
 * @brief Target::receiveProbeRequest
 * @param pdu
 */
void Target::receiveProbeRequest(ACN::PDU::Message<ProbeRequest::Pdu>)
{
}


/**
 * @brief Target::sendProbeReply
 */
void Target::sendProbeReply()
{

}


/**
 * @brief Target::receiveRdmCommand
 * @param pdu
 */
void Target::receiveRdmCommand(ACN::PDU::Message<RPT::COMMAND::Pdu> pdu)
{
  (void)pdu;
//  auto data = static_cast<RPT::COMMAND::command_data*>(pdu->data());
//  for ( auto& pid : LLRP::COMMAND::allowed_pids )
//    if (pid == data->message.parameterId)
//      return receiveRDM(RDM::MsgPtr(&data->message));
//
}

} // namespace RDMnet::LLRP
